# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "freezing effect Generator",
    "author" : "CGBlender", 
    "description" : "freezing effect Generator",
    "blender" : (3, 5, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
class SNA_PT_FREEZING_EFFECT_GENERATOR_C6861(bpy.types.Panel):
    bl_label = 'freezing effect Generator'
    bl_idname = 'SNA_PT_FREEZING_EFFECT_GENERATOR_C6861'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'FG'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        op = layout.operator('sna.fg_3e6d5', text='Apply freezing effect ', icon_value=0, emboss=True, depress=False)
        layout.label(text='Add The Right Empty Below ', icon_value=0)
        layout.prop(bpy.context.object.modifiers.active.node_group.nodes['Object Info'].inputs[0], 'default_value', text='Empty', icon_value=0, emboss=True)
        col_1855A = layout.column(heading='', align=False)
        col_1855A.alert = False
        col_1855A.enabled = True
        col_1855A.active = True
        col_1855A.use_property_split = False
        col_1855A.use_property_decorate = False
        col_1855A.scale_x = 1.0
        col_1855A.scale_y = 1.0
        col_1855A.alignment = 'Expand'.upper()
        col_1855A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Set Material'].inputs[2], 'default_value', text='ice Material', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Set Material.001'].inputs[2], 'default_value', text='ice particles Material', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Set Material.002'].inputs[2], 'default_value', text='Ice Spikes ', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Distribute Points on Faces.001'].inputs[4], 'default_value', text='Ice Density ', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Distribute Points on Faces'].inputs[4], 'default_value', text='ice particles Density ', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Math.003'].inputs[1], 'default_value', text='ice Spikes Density ', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Curve Circle'].inputs[4], 'default_value', text='Spikes Radius', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Map Range.002'].inputs[3], 'default_value', text='Spikes Scale Min', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Map Range.002'].inputs[4], 'default_value', text='Spikes Scale Max', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Curve Line'].inputs[1], 'default_value', text='Spikes Length', icon_value=0, emboss=True)
        col_1855A.prop(bpy.context.object.modifiers.active.node_group.nodes['Vector Math.003'].inputs[1], 'default_value', text='Spikes Random Density', icon_value=0, emboss=True)


class SNA_OT_Fg_3E6D5(bpy.types.Operator):
    bl_idname = "sna.fg_3e6d5"
    bl_label = "FG"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and False:
            cls.poll_message_set()
        return not False

    def execute(self, context):
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Freezing Effect .blend') + r'\NodeTree', filename='Freezing Effect ', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_9B0EF = None if not new_data else new_data[0]
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['Freezing Effect ']
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_PT_FREEZING_EFFECT_GENERATOR_C6861)
    bpy.utils.register_class(SNA_OT_Fg_3E6D5)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_PT_FREEZING_EFFECT_GENERATOR_C6861)
    bpy.utils.unregister_class(SNA_OT_Fg_3E6D5)
